unit uDd; { mk, 21.2.2004 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;
type
  TForm1 = class(TForm)
    bZeichnePolygon: TButton;
    lP0x: TLabel; lP0y: TLabel; lP1x: TLabel; lP1y: TLabel;
    lP2x: TLabel; lP2y: TLabel; lP3x: TLabel; lP3y: TLabel;
    eP0x: TEdit;  eP0y: TEdit;  eP1x: TEdit;  eP1y: TEdit;
    eP2x: TEdit;  eP2y: TEdit;  eP3x: TEdit;  eP3y: TEdit;
    lN: TLabel;  eN: TEdit;
    procedure bZeichnePolygonClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    P         : array of TPoint;  // Polygon
    gedrueckt : boolean;          // Maustaste gedrckt
    xa,ya     : integer;          // alte Mausposition
    alteFarbe : TColor;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
  gedrueckt := false;
end;

procedure TForm1.bZeichnePolygonClick(Sender: TObject);
var
  i,n : integer;
begin
  // Ecken des Polygons eingeben
  n := StrToInt(eN.Text);
  setLength(P,n);
  if (n = 3) or (n=4) then
  begin
    P[0].X := StrToInt(eP0x.text); P[0].Y := StrToInt(eP0y.text);
    P[1].X := StrToInt(eP1x.text); P[1].Y := StrToInt(eP1y.text);
    P[2].X := StrToInt(eP2x.text); P[2].Y := StrToInt(eP2y.text);
  end;
  if n = 4 then
  begin
    P[3].X := StrToInt(eP3x.text); P[3].Y := StrToInt(eP3y.text);
  end;
  // Farbe des Polygons bestimmen
  alteFarbe := canvas.Brush.Color; canvas.Brush.Color := clRed;
  // Polygon zeichen
  canvas.Polygon(P);
  // alte Farbe wieder einstellen
  canvas.Brush.Color := alteFarbe;
end;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  gedrueckt := true; xa := x; ya := y;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  gedrueckt := false; 
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i,dx,dy : integer;
begin
  if gedrueckt then
  begin
    // Differenzen bestimmen
    dx := x-xa; dy := y-ya;
    // Mauskoordinaten merken
    xa := x; ya := y;
    // neue Polygon-Koordinaten bestimmen
    for i := 0 to Length(P)-1 do
    begin
      P[i].X := P[i].X + dx;
      P[i].Y := P[i].Y + dy;
    end;
    // Zeichenbereich lschen, dh. mit Brush-Farbe fllem
    canvas.FillRect(Rect(0,0,width,height));
    // Polygon zeichen
    alteFarbe := canvas.Brush.Color;
    canvas.Brush.Color := clRed;
    canvas.Polygon(P);
    canvas.Brush.Color := alteFarbe;
  end;
end;

end.
